SystemOrganization addCategory: #ConfigurationOfRewriteTool!

Object subclass: #ConfigurationOfRewriteTool
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfRewriteTool'!

!ConfigurationOfRewriteTool class methodsFor: 'development support' stamp: 'SeanDeNigris 5/7/2015 13:34'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfRewriteTool class methodsFor: 'private' stamp: 'SeanDeNigris 5/7/2015 13:34'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfRewriteTool class methodsFor: 'private' stamp: 'SeanDeNigris 5/7/2015 13:34'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfRewriteTool class methodsFor: 'private' stamp: 'SeanDeNigris 5/7/2015 13:34'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfRewriteTool class methodsFor: 'metacello tool support' stamp: 'SeanDeNigris 5/7/2015 13:34'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfRewriteTool class methodsFor: 'loading' stamp: 'SeanDeNigris 5/7/2015 13:34'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfRewriteTool class methodsFor: 'loading' stamp: 'SeanDeNigris 5/7/2015 13:34'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfRewriteTool class methodsFor: 'loading' stamp: 'SeanDeNigris 5/7/2015 13:34'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfRewriteTool class methodsFor: 'accessing' stamp: 'SeanDeNigris 5/7/2015 13:34'!
project

	^self new project! !

!ConfigurationOfRewriteTool class methodsFor: 'development support' stamp: 'SeanDeNigris 5/7/2015 13:34'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfRewriteTool methodsFor: 'baselines' stamp: 'SeanDeNigris 5/7/2015 13:39'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/RewriteTool/main/'.
		spec 
			package: 'RewriteTool';
			package: 'RewriteRulesDemo'.
		spec 
			group: 'default' with: #('RewriteTool');
			group: 'Examples' with: #('default' 'RewriteRulesDemo'). ].
! !

!ConfigurationOfRewriteTool methodsFor: 'accessing' stamp: 'SeanDeNigris 5/7/2015 13:34'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfRewriteTool methodsFor: 'symbolic versions' stamp: 'SeanDeNigris 5/7/2015 13:40'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfRewriteTool methodsFor: 'accessing' stamp: 'SeanDeNigris 5/7/2015 13:34'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfRewriteTool methodsFor: 'symbolic versions' stamp: 'SeanDeNigris 5/7/2015 13:40'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfRewriteTool methodsFor: 'versions' stamp: 'SeanDeNigris 5/7/2015 13:40'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '5/7/2015 13:40'.
		spec 
			package: 'RewriteTool' with: 'RewriteTool-MarkRizun.72';
			package: 'RewriteRulesDemo' with: 'RewriteRulesDemo-MarkRizun.3'. ].
! !
